// Moebius 05
// Versione Finale Si costruisce un anello a partire da una qualunque sezione
// Si introduce una nuova classe per la gestione delle sezioni
#ifndef CIMOEBIUS_H
#define CIMOEBIUS_H

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#include <GL/gl.h>	
#include <GL/glu.h>	
#include <stdlib.h>
#include <time.h>
#include <vcg/Point3.h>
#include <vcg/Matrix44.h>
#include <vector>
using namespace vcg;
using namespace std;
class CIMoebius
{
public:

	class myVertex
	{
	public :
		myVertex(){}
		myVertex(Point3d &pp, Point4d &nn) {p=pp; n=Point3d(nn[0],nn[1],nn[2]);}
		Point3d p;
		Point3d n;
		Point4d n4() {return Point4d(n[0],n[1],n[2],0);}
	};

	class myFace
	{
	public:
		myFace(myVertex *v0, myVertex *v1, myVertex *v2);
		void ComputeNormal();

		myVertex *v[3];
		Point3d n;
	};

	class myMesh {
	public:
		vector< myVertex > vert;
		vector< myFace > face;
		void ComputeFaceNormal();
		void Draw() const ;
		bool empty() const {return vert.empty();}
		void clear() {vert.clear(); face.clear();}
	};


	// Classe per tenere un poligono con normali ai vertici nel piano XY
	// da usare come sezione per l'anello di moebius
	class myShape
	{
	public:
		vector<myVertex> poly;
		void ComputeNormals();
		void BuildNGon(int n, double rad);
	};

void GenerateMoebiusRing(myShape &s, int step, float r, float twistDeg);


myMesh m;

};

#endif